! vi: set sw=4 ts=8:

module gt3conv_tools
    use gt3read
    use gtool
    implicit none

!    private
    public dims_table

    ! DIMTABLE_ENTRY : ѿ˴ؤ
    type DIMTABLE_ENTRY
	character(len = 30):: name    ! ̾. lon, lat ʤ
	character(len = 16):: item    ! եʤ ITEM, ATIM?
	character(len = 16 * 2):: long_name ! Ĺ̾
	character(len = 16):: unit ! ñ
	integer:: lower, upper        ! ASTR1  AEND1
	integer:: dim                 ! γʻ
	real, pointer:: values(:)     ! 㤨гʻ
    end type

    type(DIMTABLE_ENTRY), save, pointer:: dims_table(:)

contains

    type(VSTRING) function AxisFilename(item, weight) result(result)
	character(len = 16), intent(in):: item
	logical, intent(in), optional:: weight
	character(len = *), parameter:: GTAXDIR_L = '/var/spool/gt3-dcl5/'
	character(len = *), parameter:: GTAXDIR_W = '/home/momoko/lib/gt3/'
	character(len = 8):: prefix
	logical:: exist
    continue
	print *, item
	prefix = 'GTAXLOC.'
	if (present(weight)) then
	    if (weight) prefix = 'GTAXWGT.'
	endif
	result = prefix // trim(item)
	inquire(file=vchar(result,len(result)), exist=exist)
	if (exist) return
	result = GTAXDIR_L // prefix // trim(item)
	inquire(file=vchar(result,len(result)), exist=exist)
	if (exist) return
	result = GTAXDIR_W // prefix // trim(item)
	inquire(file=vchar(result,len(result)), exist=exist)
!	if (exist) return
!	result = GtoolGetenv('GTAXDIR') // prefix // trim(item)
!	inquire(file=vchar(result,len(result)), exist=exist)
!           ĶѿμߤäƤɤ????
    end function


    subroutine ReadAxisFile(dim)
	type(DIMTABLE_ENTRY), intent(inout):: dim
	type(GT3_FILE):: axisfile
	type(GT3_HEADER):: header
	real, pointer:: buffer(:, :, :)
	integer:: lb, ub
    continue
	call Open(axisfile, &
                & vchar(AxisFilename(dim%item), len(AxisFilename(dim%item))))
	call Get(axisfile, header, buffer)
	call Close(axisfile)

	lb = lbound(buffer, 1)
	ub = ubound(buffer, 1)
	if (dim%lower < lb) then
	    print *, 'gt3conv#ReadAxisFile: requested lower bound ', &
		& dim%lower, ' is less than axis file value ', lb
	    stop
	endif
	if (dim%upper > ub) then
	    print *, 'gt3conv#ReadAxisFile: requested upper bound ', &
		& dim%upper, ' is greater than axis file value ', ub
	    stop
	endif
	allocate(dim%values(lb: ub))
	dim%values(:) = buffer(lb: ub, lbound(buffer, 2), lbound(buffer, 3))
        dim%long_name = header%title
	if (header%unit /= '') then
	    dim%unit = UnitString(header)
	endif
    end subroutine

    type(VSTRING) function Dimname3to4(item, usedname) result(result)
	character(len = *), intent(in):: item
	character(len = *), intent(in):: usedname(:)
	character(len = len(item)):: buffer
	type(VSTRING):: name, grids, suffix
	integer:: a, b, c
    continue
	buffer = adjustl(item)
	a = scan(buffer, '0123456789')
	name = buffer(1: a-1)
	b = verify(buffer(a: ), '0123456789')
	if (b == 0) b = len(buffer)
	grids = buffer(a: b)
	suffix = trim(buffer(b + 1: ))

	if (name == 'CSIG' .and. suffix == '.M') then
	    result = 'sigma_bound'
	else if (name == 'CSIG') then
	    result = 'sigma'
	else if (name == 'GLON') then
	    result = 'lon'
	else if (name == 'GGLA') then
	    result = 'lat'
	else
	    result = item
	endif
	if (all(usedname(:) /= vchar(result,len(result)))) return

	result = result // grids
	if (all(usedname(:) /= vchar(result,len(result)))) return

	name = result
	do, c = 1, huge(c)
	    result = name // char(c)
	    if (all(usedname(:) /= vchar(result,len(result)))) return
	enddo
	stop 'gt3conv#Dimname3to4'
    end function

    subroutine StoreDimension(header, ia)
        type(GT3_HEADER), intent(in):: header
        ! integer:: length
        integer, intent(in):: ia
        integer, save:: num_dims
	character(len = 16):: item
        integer:: idim
        type(DIMTABLE_ENTRY), pointer:: dims_tmp(:)
    continue
        ! ʤФ
	item = header%axis_item(ia)
	if (item == '') return

        ! ϿѤߤɤγǧ
        do, idim = 1, num_dims
            if (item == dims_table(idim)%item) then
                 continue ! 岼üγǧ餤Ϥ褦ˤ.
                 return
            end if
        end do

        ! ̤ϿʤϿ
        num_dims = num_dims +1
	    if (num_dims > size(dims_table)) then
		allocate(dims_tmp(size(dims_table) + 1))
                ! ˭ķΥǤ + 2 ˤʤäƤ....
		dims_tmp(1: size(dims_table)) = dims_table(:)
	        ! deallocate(dims_table)
                ! deallocate(dims_table) äƤޤȥ顼ˤʤ.
		dims_table => dims_tmp
	    endif
        dims_table(num_dims)%item =  header%axis_item(ia)
        dims_table(num_dims)%lower =  header%axis_start(ia)
        dims_table(num_dims)%upper = header%axis_end(ia)
        dims_table(num_dims)%dim = dims_table(num_dims)%upper &
                 & - dims_table(num_dims)%lower + 1
   end subroutine

    type(VSTRING) function UnitString(header)
	type(GT3_HEADER), intent(in):: header
    continue
	if (header%unit == 'deg') then
	    if (header%item(1: 4) == 'GLON') then
		UnitString = 'degree_east'
	    else
		UnitString = 'degree_north'
	    endif
	else if (header%unit == '') then
            ! ̵(sigma )λñ̤϶ʸ. 
            ! ˤ줷ˡ̵󤫤?
            UnitString = ' '
	else
	    UnitString = header%unit
	endif
    end function



end module
